#ifndef PLAYER_H
#define PLAYER_H

#include "actor.h"

class Player : public Actor, public std::enable_shared_from_this<Player>
{
public:
    explicit Player();
    virtual ~Player() override;

    virtual void commitAction() override;
    virtual void moveToLocation(const std::shared_ptr<Location>& location) override;
    virtual void giveItem(const std::shared_ptr<Item>& item) override;
    virtual void useItem(const std::shared_ptr<Item>& item) override;

private:
    std::string showInventory() const;
};

#endif // PLAYER_H
