#include "location.h"
#include <algorithm>

Location::Location(Initializer &&initializer) :
    _interaction_message(initializer.message),
    _interactive_controllers(initializer.interactive_controllers),
    _is_visited(false)
{}

const std::string& Location::interact()
{
    _is_visited = true;
    return _interaction_message;
}

const std::list<std::shared_ptr<Controller>>& Location::controllers()
{
    return _interactive_controllers;
}

bool Location::isVisited() const
{
    return _is_visited;
}
