#include <iostream>

#include "controller.h"
#include "player.h"
#include "sandboxlevelbuilder.h"

int main()
{
    std::unique_ptr<LevelBuilder> level_builder = std::make_unique<SandboxLevelBuilder>();
    level_builder->init();

    std::shared_ptr<Player> player = std::make_unique<Player>();
    const auto& starting_controller = level_builder->getStartingController();
    std::cout << starting_controller->interact(player) << "\n\n";

    while (true)
    {
        player->commitAction();
    }
}
