#include "locationrequiredpolicy.h"
#include "location.h"

LocationRequiredPolicy::LocationRequiredPolicy(const std::string& satisfaction, const std::string& dissatisfaction) :
    Policy(satisfaction, dissatisfaction)
{}

LocationRequiredPolicy::~LocationRequiredPolicy()
{}

Policy::CheckResult LocationRequiredPolicy::check() const
{
    bool success = _location->isVisited();
    return composeMessageFromResult(success);
}

void LocationRequiredPolicy::setRequiredLocation(const std::shared_ptr<Location> &location)
{
    _location = location;
}
